(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global.ReduxDeepDiff = {})));
}(this, (function (exports) { 'use strict';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _sliceIterator(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _slicedToArray(arr, i) {
  if (Array.isArray(arr)) {
    return arr;
  } else if (Symbol.iterator in Object(arr)) {
    return _sliceIterator(arr, i);
  } else {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }
}

function _toConsumableArray(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
}

var UNDO="@@redux-deep-diff/UNDO";var REDO="@@redux-deep-diff/REDO";var JUMP="@@redux-deep-diff/JUMP";var undo=function undo(){return{type:UNDO}};var redo=function redo(){return{type:REDO}};var jump=function jump(index){return{type:JUMP,index:index}};

var isobject=function isObject(val){return val!=null&&_typeof(val)==="object"&&Array.isArray(val)===false};

function isObjectObject(o){return isobject(o)===true&&Object.prototype.toString.call(o)==="[object Object]"}var isPlainObject=function isPlainObject(o){var ctor,prot;if(isObjectObject(o)===false)return false;ctor=o.constructor;if(typeof ctor!=="function")return false;prot=ctor.prototype;if(isObjectObject(prot)===false)return false;if(prot.hasOwnProperty("isPrototypeOf")===false){return false}return true};

var isExtendable=function isExtendable(val){return typeof val!=="undefined"&&val!==null&&(_typeof(val)==="object"||typeof val==="function")};

var forIn=function forIn(obj,fn,thisArg){for(var key in obj){if(fn.call(thisArg,obj[key],key,obj)===false){break}}};

function mixin(target,objects){if(!isExtendable(target)){throw new TypeError("mixin-object expects the first argument to be an object.")}var len=arguments.length,i=0;while(++i<len){var obj=arguments[i];if(isExtendable(obj)){forIn(obj,copy,target);}}return target}function copy(value,key){this[key]=value;}var mixinObject=mixin;

var toString=Object.prototype.toString;var kindOf=function kindOf(val){var type=_typeof(val);if(type==="undefined"){return"undefined"}if(val===null){return"null"}if(val===true||val===false||val instanceof Boolean){return"boolean"}if(type==="string"||val instanceof String){return"string"}if(type==="number"||val instanceof Number){return"number"}if(type==="function"||val instanceof Function){if(typeof val.constructor.name!=="undefined"&&val.constructor.name.slice(0,9)==="Generator"){return"generatorfunction"}return"function"}if(typeof Array.isArray!=="undefined"&&Array.isArray(val)){return"array"}if(val instanceof RegExp){return"regexp"}if(val instanceof Date){return"date"}type=toString.call(val);if(type==="[object RegExp]"){return"regexp"}if(type==="[object Date]"){return"date"}if(type==="[object Arguments]"){return"arguments"}if(type==="[object Error]"){return"error"}if(type==="[object Promise]"){return"promise"}if(isBuffer(val)){return"buffer"}if(type==="[object Set]"){return"set"}if(type==="[object WeakSet]"){return"weakset"}if(type==="[object Map]"){return"map"}if(type==="[object WeakMap]"){return"weakmap"}if(type==="[object Symbol]"){return"symbol"}if(type==="[object Map Iterator]"){return"mapiterator"}if(type==="[object Set Iterator]"){return"setiterator"}if(type==="[object Int8Array]"){return"int8array"}if(type==="[object Uint8Array]"){return"uint8array"}if(type==="[object Uint8ClampedArray]"){return"uint8clampedarray"}if(type==="[object Int16Array]"){return"int16array"}if(type==="[object Uint16Array]"){return"uint16array"}if(type==="[object Int32Array]"){return"int32array"}if(type==="[object Uint32Array]"){return"uint32array"}if(type==="[object Float32Array]"){return"float32array"}if(type==="[object Float64Array]"){return"float64array"}return"object"};function isBuffer(val){return val.constructor&&typeof val.constructor.isBuffer==="function"&&val.constructor.isBuffer(val)}

function clone(val){var type=kindOf(val);if(clone.hasOwnProperty(type)){return clone[type](val)}return val}clone.array=function cloneArray(arr){return arr.slice()};clone.date=function cloneDate(date){return new Date(+date)};clone.object=function cloneObject(obj){if(isExtendable(obj)){return mixinObject({},obj)}else{return obj}};clone.regexp=function cloneRegExp(re){var flags="";flags+=re.multiline?"m":"";flags+=re.global?"g":"";flags+=re.ignorecase?"i":"";return new RegExp(re.source,flags)};var shallowClone=clone;

var toString$1=Object.prototype.toString;var kindOf$2=function kindOf(val){var type=_typeof(val);if(type==="undefined"){return"undefined"}if(val===null){return"null"}if(val===true||val===false||val instanceof Boolean){return"boolean"}if(type==="string"||val instanceof String){return"string"}if(type==="number"||val instanceof Number){return"number"}if(type==="function"||val instanceof Function){if(typeof val.constructor.name!=="undefined"&&val.constructor.name.slice(0,9)==="Generator"){return"generatorfunction"}return"function"}if(typeof Array.isArray!=="undefined"&&Array.isArray(val)){return"array"}if(val instanceof RegExp){return"regexp"}if(val instanceof Date){return"date"}type=toString$1.call(val);if(type==="[object RegExp]"){return"regexp"}if(type==="[object Date]"){return"date"}if(type==="[object Arguments]"){return"arguments"}if(type==="[object Error]"){return"error"}if(type==="[object Promise]"){return"promise"}if(isBuffer$1(val)){return"buffer"}if(type==="[object Set]"){return"set"}if(type==="[object WeakSet]"){return"weakset"}if(type==="[object Map]"){return"map"}if(type==="[object WeakMap]"){return"weakmap"}if(type==="[object Symbol]"){return"symbol"}if(type==="[object Map Iterator]"){return"mapiterator"}if(type==="[object Set Iterator]"){return"setiterator"}if(type==="[object Int8Array]"){return"int8array"}if(type==="[object Uint8Array]"){return"uint8array"}if(type==="[object Uint8ClampedArray]"){return"uint8clampedarray"}if(type==="[object Int16Array]"){return"int16array"}if(type==="[object Uint16Array]"){return"uint16array"}if(type==="[object Int32Array]"){return"int32array"}if(type==="[object Uint32Array]"){return"uint32array"}if(type==="[object Float32Array]"){return"float32array"}if(type==="[object Float64Array]"){return"float64array"}return"object"};function isBuffer$1(val){return val.constructor&&typeof val.constructor.isBuffer==="function"&&val.constructor.isBuffer(val)}

var forIn$3=function forIn(obj,fn,thisArg){for(var key in obj){if(fn.call(thisArg,obj[key],key,obj)===false){break}}};

var hasOwn=Object.prototype.hasOwnProperty;var forOwn=function forOwn(obj,fn,thisArg){forIn$3(obj,function(val,key){if(hasOwn.call(obj,key)){return fn.call(thisArg,obj[key],key,obj)}});};

function cloneDeep(val,instanceClone){switch(kindOf$2(val)){case"object":return cloneObjectDeep(val,instanceClone);case"array":return cloneArrayDeep(val,instanceClone);default:{return shallowClone(val)}}}function cloneObjectDeep(obj,instanceClone){if(isPlainObject(obj)){var res={};forOwn(obj,function(obj,key){this[key]=cloneDeep(obj,instanceClone);},res);return res}else if(instanceClone){return instanceClone(obj)}else{return obj}}function cloneArrayDeep(arr,instanceClone){var len=arr.length,res=[];var i=-1;while(++i<len){res[i]=cloneDeep(arr[i],instanceClone);}return res}var cloneDeep_1=cloneDeep;

var $scope,conflict,conflictResolution=[];if((typeof global==="undefined"?"undefined":_typeof(global))==="object"&&global){$scope=global;}else if(typeof window!=="undefined"){$scope=window;}else{$scope={};}conflict=$scope.DeepDiff;if(conflict){conflictResolution.push(function(){if("undefined"!==typeof conflict&&$scope.DeepDiff===accumulateDiff){$scope.DeepDiff=conflict;conflict=undefined;}});}function inherits(ctor,superCtor){ctor.super_=superCtor;ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:false,writable:true,configurable:true}});}function Diff(kind,path){Object.defineProperty(this,"kind",{value:kind,enumerable:true});if(path&&path.length){Object.defineProperty(this,"path",{value:path,enumerable:true});}}function DiffEdit(path,origin,value){DiffEdit.super_.call(this,"E",path);Object.defineProperty(this,"lhs",{value:origin,enumerable:true});Object.defineProperty(this,"rhs",{value:value,enumerable:true});}inherits(DiffEdit,Diff);function DiffNew(path,value){DiffNew.super_.call(this,"N",path);Object.defineProperty(this,"rhs",{value:value,enumerable:true});}inherits(DiffNew,Diff);function DiffDeleted(path,value){DiffDeleted.super_.call(this,"D",path);Object.defineProperty(this,"lhs",{value:value,enumerable:true});}inherits(DiffDeleted,Diff);function DiffArray(path,index,item){DiffArray.super_.call(this,"A",path);Object.defineProperty(this,"index",{value:index,enumerable:true});Object.defineProperty(this,"item",{value:item,enumerable:true});}inherits(DiffArray,Diff);function arrayRemove(arr,from,to){var rest=arr.slice((to||from)+1||arr.length);arr.length=from<0?arr.length+from:from;arr.push.apply(arr,rest);return arr}function realTypeOf(subject){var type=_typeof(subject);if(type!=="object"){return type}if(subject===Math){return"math"}else if(subject===null){return"null"}else if(Array.isArray(subject)){return"array"}else if(Object.prototype.toString.call(subject)==="[object Date]"){return"date"}else if(typeof subject.toString==="function"&&/^\/.*\//.test(subject.toString())){return"regexp"}return"object"}function deepDiff(lhs,rhs,changes,prefilter,path,key,stack){path=path||[];stack=stack||[];var currentPath=path.slice(0);if(typeof key!=="undefined"){if(prefilter){if(typeof prefilter==="function"&&prefilter(currentPath,key)){return}else if(_typeof(prefilter)==="object"){if(prefilter.prefilter&&prefilter.prefilter(currentPath,key)){return}if(prefilter.normalize){var alt=prefilter.normalize(currentPath,key,lhs,rhs);if(alt){lhs=alt[0];rhs=alt[1];}}}}currentPath.push(key);}if(realTypeOf(lhs)==="regexp"&&realTypeOf(rhs)==="regexp"){lhs=lhs.toString();rhs=rhs.toString();}var ltype=_typeof(lhs);var rtype=_typeof(rhs);var ldefined=ltype!=="undefined"||stack&&stack[stack.length-1].lhs&&stack[stack.length-1].lhs.hasOwnProperty(key);var rdefined=rtype!=="undefined"||stack&&stack[stack.length-1].rhs&&stack[stack.length-1].rhs.hasOwnProperty(key);if(!ldefined&&rdefined){changes(new DiffNew(currentPath,rhs));}else if(!rdefined&&ldefined){changes(new DiffDeleted(currentPath,lhs));}else if(realTypeOf(lhs)!==realTypeOf(rhs)){changes(new DiffEdit(currentPath,lhs,rhs));}else if(realTypeOf(lhs)==="date"&&lhs-rhs!==0){changes(new DiffEdit(currentPath,lhs,rhs));}else if(ltype==="object"&&lhs!==null&&rhs!==null){if(!stack.filter(function(x){return x.lhs===lhs}).length){stack.push({lhs:lhs,rhs:rhs});if(Array.isArray(lhs)){var i,len=lhs.length;for(i=0;i<lhs.length;i++){if(i>=rhs.length){changes(new DiffArray(currentPath,i,new DiffDeleted(undefined,lhs[i])));}else{deepDiff(lhs[i],rhs[i],changes,prefilter,currentPath,i,stack);}}while(i<rhs.length){changes(new DiffArray(currentPath,i,new DiffNew(undefined,rhs[i++])));}}else{var akeys=Object.keys(lhs);var pkeys=Object.keys(rhs);akeys.forEach(function(k,i){var other=pkeys.indexOf(k);if(other>=0){deepDiff(lhs[k],rhs[k],changes,prefilter,currentPath,k,stack);pkeys=arrayRemove(pkeys,other);}else{deepDiff(lhs[k],undefined,changes,prefilter,currentPath,k,stack);}});pkeys.forEach(function(k){deepDiff(undefined,rhs[k],changes,prefilter,currentPath,k,stack);});}stack.length=stack.length-1;}else if(lhs!==rhs){changes(new DiffEdit(currentPath,lhs,rhs));}}else if(lhs!==rhs){if(!(ltype==="number"&&isNaN(lhs)&&isNaN(rhs))){changes(new DiffEdit(currentPath,lhs,rhs));}}}function accumulateDiff(lhs,rhs,prefilter,accum){accum=accum||[];deepDiff(lhs,rhs,function(diff){if(diff){accum.push(diff);}},prefilter);return accum.length?accum:undefined}function applyArrayChange(arr,index,change){if(change.path&&change.path.length){var it=arr[index],i,u=change.path.length-1;for(i=0;i<u;i++){it=it[change.path[i]];}switch(change.kind){case"A":applyArrayChange(it[change.path[i]],change.index,change.item);break;case"D":delete it[change.path[i]];break;case"E":case"N":it[change.path[i]]=change.rhs;break;}}else{switch(change.kind){case"A":applyArrayChange(arr[index],change.index,change.item);break;case"D":arr=arrayRemove(arr,index);break;case"E":case"N":arr[index]=change.rhs;break;}}return arr}function applyChange(target,source,change){if(target&&source&&change&&change.kind){var it=target,i=-1,last=change.path?change.path.length-1:0;while(++i<last){if(typeof it[change.path[i]]==="undefined"){it[change.path[i]]=typeof change.path[i]==="number"?[]:{};}it=it[change.path[i]];}switch(change.kind){case"A":applyArrayChange(change.path?it[change.path[i]]:it,change.index,change.item);break;case"D":delete it[change.path[i]];break;case"E":case"N":it[change.path[i]]=change.rhs;break;}}}function revertArrayChange(arr,index,change){if(change.path&&change.path.length){var it=arr[index],i,u=change.path.length-1;for(i=0;i<u;i++){it=it[change.path[i]];}switch(change.kind){case"A":revertArrayChange(it[change.path[i]],change.index,change.item);break;case"D":it[change.path[i]]=change.lhs;break;case"E":it[change.path[i]]=change.lhs;break;case"N":delete it[change.path[i]];break;}}else{switch(change.kind){case"A":revertArrayChange(arr[index],change.index,change.item);break;case"D":arr[index]=change.lhs;break;case"E":arr[index]=change.lhs;break;case"N":arr=arrayRemove(arr,index);break;}}return arr}function revertChange(target,source,change){if(target&&source&&change&&change.kind){var it=target,i,u;u=change.path.length-1;for(i=0;i<u;i++){if(typeof it[change.path[i]]==="undefined"){it[change.path[i]]={};}it=it[change.path[i]];}switch(change.kind){case"A":revertArrayChange(it[change.path[i]],change.index,change.item);break;case"D":it[change.path[i]]=change.lhs;break;case"E":it[change.path[i]]=change.lhs;break;case"N":delete it[change.path[i]];break;}}}function applyDiff(target,source,filter){if(target&&source){var onChange=function onChange(change){if(!filter||filter(target,source,change)){applyChange(target,source,change);}};deepDiff(target,source,onChange);}}Object.defineProperties(accumulateDiff,{diff:{value:accumulateDiff,enumerable:true},observableDiff:{value:deepDiff,enumerable:true},applyDiff:{value:applyDiff,enumerable:true},applyChange:{value:applyChange,enumerable:true},revertChange:{value:revertChange,enumerable:true},isConflict:{value:function value(){return"undefined"!==typeof conflict},enumerable:true},noConflict:{value:function value(){if(conflictResolution){conflictResolution.forEach(function(it){it();});conflictResolution=null;}return accumulateDiff},enumerable:true}});

var applyChange$1=accumulateDiff.applyChange,revertChange$1=accumulateDiff.revertChange;function doChanges(applyOrRevertChange,target){var changes=arguments.length>2&&arguments[2]!==undefined?arguments[2]:[];for(var i=0,l=changes.length;i<l;i++){applyOrRevertChange(target,target,changes[i]);}return target}function doDiffs(applyOrRevertChange,target){var diffs=arguments.length>2&&arguments[2]!==undefined?arguments[2]:[];for(var i=0,l=diffs.length;i<l;i++){doChanges(applyOrRevertChange,target,diffs[i]);}return target}var applyChanges=doChanges.bind(null,applyChange$1);var applyDiffs=doDiffs.bind(null,applyChange$1);var revertChanges=doChanges.bind(null,revertChange$1);var revertDiffs=doDiffs.bind(null,revertChange$1);

function createDeducer(selector){var config=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var _config$key=config.key,key=_config$key===void 0?"diff":_config$key,_config$next=config.next,next=_config$next===void 0?false:_config$next,_config$unique=config.unique,unique=_config$unique===void 0?false:_config$unique,_config$index=config.index,index=_config$index===void 0?false:_config$index,_config$range=config.range,range=_config$range===void 0?false:_config$range,_config$limit=config.limit,limit=_config$limit===void 0?false:_config$limit;if(index!==false&&(range||limit)||range&&limit){console.warn("index, range, or limit should not be combined");}var makeChanges=next?applyChanges:revertChanges;var deducer=function deducer(rawState){var history=rawState[key],state=_objectWithoutProperties(rawState,[key]);state=cloneDeep_1(state);if(!history||!(history.prev&&history.next)){throw new Error("\"".concat(key,"\" is not a diff history object"))}var diffs=next?history.next:history.prev;if(deducer.cache.self){var _deducer$cache$self=_slicedToArray(deducer.cache.self,2),cached=_deducer$cache$self[0],result=_deducer$cache$self[1];if(diffs===cached)return result}var length=diffs.length;var _ref=range||[0,(limit||length)-1],_ref2=_slicedToArray(_ref,2),lower=_ref2[0],upper=_ref2[1];lower=index!==false?index:Math.max(lower,0);upper=index!==false?index:Math.min(upper,length-1);var deduced=[];for(var _len=arguments.length,args=new Array(_len>1?_len-1:0),_key=1;_key<_len;_key++){args[_key-1]=arguments[_key];}for(var i=0;i<=length;i++){makeChanges(state,diffs[i]);if(i<lower||i>upper)continue;var cacheId=i-length;var _ref3=deducer.cache[cacheId]||[],_ref4=_slicedToArray(_ref3,2),_cached=_ref4[0],_result=_ref4[1];if(!_cached||diffs[i]!==_cached){_result=selector.apply(void 0,[state].concat(args));deducer.cache[cacheId]=[diffs[i],_result];}if(unique){var last=next?deduced[deduced.length-1]:deduced[0];if(_result===last)continue}if(index===false){if(next){deduced.push(_result);}else{deduced.unshift(_result);}}else if(i===index){return _result}}deduced=index===false?deduced:null;deducer.cache.self=[diffs,deduced];return deduced};deducer.cache={};return deducer}

var _diff=accumulateDiff.diff;function isPathsEqual(actual,expected){return actual.length===expected.length&&actual.every(function(k,i){return k===expected[i]})}function getSubjectAtPath(target,path){return _typeof(target)!=="object"?null:path.reduce(function(value,key){return typeof!value==="undefined"?value:value[key]},target)}function mergeChanges(a,b){var merged={};if(a.lhs!==b.rhs){if(a.kind==="A"||b.kind==="A"){var item=mergeChanges(a.kind==="A"?a.item:{kind:a.kind,lhs:a.lhs},b.kind==="A"?b.item:{kind:b.kind,rhs:b.rhs});if(item&&item.kind){merged=a.kind==="A"?_extends({},a,{item:item}):_extends({},b,{item:item});}}else if(a.kind!=="D"&&b.kind==="E"){merged=_extends({},a,{rhs:b.rhs});}else if(a.kind==="D"&&b.kind!=="D"){merged={kind:"E",path:a.path,lhs:a.lhs,rhs:b.rhs};}else if(a.kind!=="D"&&b.kind==="D"){merged=_extends({},b,{lhs:a.lhs});}else{return}}return merged}var DiffAccumulator=function(){function DiffAccumulator(){var _this=this;var _ref=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{},flatten=_ref.flatten,prefilter=_ref.prefilter;_classCallCheck(this,DiffAccumulator);Object.defineProperty(this,"flattened",{configurable:true,enumerable:true,writable:true,value:[]});Object.defineProperty(this,"changes",{configurable:true,enumerable:true,writable:true,value:[]});Object.defineProperty(this,"lhs",{configurable:true,enumerable:true,writable:true,value:null});Object.defineProperty(this,"rhs",{configurable:true,enumerable:true,writable:true,value:null});Object.defineProperty(this,"prefilter",{configurable:true,enumerable:true,writable:true,value:function value(path,key){if(_this.isFlattened(_toConsumableArray(path).concat([key]))){return true}else if(_this.opts.prefilter){return _this.opts.prefilter(path,key)}else{return false}}});this.opts={flatten:flatten,prefilter:prefilter};}_createClass(DiffAccumulator,[{key:"diff",value:function diff(lhs,rhs){this.flattened=[];this.lhs=lhs;this.rhs=rhs;_diff(lhs,rhs,this.prefilter,this);return this.changes}},{key:"clear",value:function clear(){this.changes=[];}},{key:"getFlatPath",value:function getFlatPath(change){var _this2=this;var index=-1;if(this.opts.flatten){index=change.path.findIndex(function(key,i,path){return _this2.opts.flatten(path.slice(0,i),key)});}return index>=0?change.path.slice(0,index+1):change.path}},{key:"isFlattened",value:function isFlattened(path){return this.flattened.some(function(done){return isPathsEqual(done,path)})}},{key:"addChange",value:function addChange(change){var existingIndex=this.changes.findIndex(function(c){var pathA=change.kind==="A"?_toConsumableArray(change.path).concat([change.index]):change.path;var pathB=c.kind==="A"?_toConsumableArray(c.path).concat([c.index]):c.path;return isPathsEqual(pathA,pathB)});if(change.item){change=_extends({},change,{item:_extends({},change.item)});}else{change=_extends({},change);}if(existingIndex>-1){var merged=mergeChanges(this.changes[existingIndex],change);if(merged&&!merged.kind){this.changes.splice(existingIndex,1);}else if(merged){this.changes.splice(existingIndex,1,merged);}}else{this.changes.push(change);}}},{key:"push",value:function push(change){var flatPath=this.getFlatPath(change);if(this.isFlattened(flatPath))return;if(change.kind!=="A"&&!isPathsEqual(flatPath,change.path)){var lhs=getSubjectAtPath(this.lhs,flatPath);var rhs=getSubjectAtPath(this.rhs,flatPath);this.addChange({kind:"E",path:flatPath,lhs:lhs,rhs:rhs});this.flattened.push(flatPath);}else{this.addChange(change);}}}]);return DiffAccumulator}();

function addToHistory(history,addition){return addition.length===0?history:_extends({},history,{prev:[addition].concat(_toConsumableArray(history.prev)).slice(0,history.limit||history.prev.length+1),next:[]})}function jumpToPrevHistory(history){var offset=arguments.length>1&&arguments[1]!==undefined?arguments[1]:1;offset=Math.min(history.prev.length,offset);return _extends({},history,{prev:history.prev.slice(offset),next:_toConsumableArray(history.prev.slice(0,offset).reverse()).concat(_toConsumableArray(history.next)).slice(0,history.limit||history.next.length+offset)})}function jumpToNextHistory(history){var offset=arguments.length>1&&arguments[1]!==undefined?arguments[1]:1;offset=Math.min(history.next.length,offset);return _extends({},history,{prev:_toConsumableArray(history.next.slice(0,offset).reverse()).concat(_toConsumableArray(history.prev)).slice(0,history.limit||history.prev.length+offset),next:history.next.slice(offset)})}function diff(reducer){var config=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var _config$key=config.key,key=_config$key===void 0?"diff":_config$key,_config$limit=config.limit,limit=_config$limit===void 0?0:_config$limit,_config$undoType=config.undoType,undoType=_config$undoType===void 0?UNDO:_config$undoType,_config$redoType=config.redoType,redoType=_config$redoType===void 0?REDO:_config$redoType,_config$jumpType=config.jumpType,jumpType=_config$jumpType===void 0?JUMP:_config$jumpType,_config$skipAction=config.skipAction,skipAction=_config$skipAction===void 0?function(){return false}:_config$skipAction,_config$initialState=config.initialState,initialState=_config$initialState===void 0?{prev:[],next:[]}:_config$initialState,_config$ignoreInit=config.ignoreInit,ignoreInit=_config$ignoreInit===void 0?true:_config$ignoreInit,_config$flatten=config.flatten,flatten=_config$flatten===void 0?function(){return false}:_config$flatten,_config$prefilter=config.prefilter,prefilter=_config$prefilter===void 0?function(){return false}:_config$prefilter;var accum=new DiffAccumulator({flatten:flatten,prefilter:prefilter});return function(rawState,action){var _ref=rawState||{},history=_ref[key],state=_objectWithoutProperties(_ref,[key]);history=history||_extends({},initialState,{limit:limit});var lhs=rawState&&state;var rhs=reducer(lhs,action);var nextState=rhs||{};var changes,diffs;switch(action.type){case undoType:nextState=revertChanges(cloneDeep_1(lhs),history.prev[0]);history=jumpToPrevHistory(history);break;case redoType:nextState=applyChanges(cloneDeep_1(lhs),history.next[0]);history=jumpToNextHistory(history);break;case jumpType:if(action.index<0){diffs=history.prev.slice(0,Math.abs(action.index));nextState=revertDiffs(cloneDeep_1(lhs),diffs);history=jumpToPrevHistory(history,Math.abs(action.index));}else if(action.index>0){diffs=history.next.slice(0,Math.abs(action.index));nextState=applyDiffs(cloneDeep_1(lhs),diffs);history=jumpToNextHistory(history,action.index);}break;default:changes=rawState||!ignoreInit?accum.diff(lhs,rhs):[];if(!skipAction(action)){history=addToHistory(history,changes);accum.clear();}}return _extends({},nextState,_defineProperty({},key,history))}}

exports.createDeducer = createDeducer;
exports.default = diff;
exports.UNDO = UNDO;
exports.REDO = REDO;
exports.JUMP = JUMP;
exports.undo = undo;
exports.redo = redo;
exports.jump = jump;

Object.defineProperty(exports, '__esModule', { value: true });

})));
